{% extends "base_device.yaml.jinja2" %}

{% block device_setup %}
device_type: xilinx-zcu102

job_name: {{ lava_job_name }}

timeouts:
  job:
    minutes: 60
  action:
    minutes: 20
  connection:
    minutes: 20

priority: medium

visibility: public

context:
  test_character_delay: 30
  lava_test_results_dir: /var/lib/lava-%s

actions:

- deploy:
    to: downloads
    failure_retry: 3
    timeout:
      minutes: 60
    images:
      firmware:
        url: {{ firmware_url }}
        {%- set firmware_path, firmware_extension = splitext(firmware_url) %}
        compression: {{ firmware_extension[1:] }}
      os:
        url: {{ os_url }}
        {%- set os_path, os_extension = splitext(os_url) %}
        compression: {{ os_extension[1:] }}
      script:
        url: https://gitlab.com/Linaro/blueprints/ci/-/raw/HEAD/support_files/merge-images.py
      {%- if testexport_url %}
      testexport:
        url: {{ testexport_url }}
      {%- endif %}
    postprocess:
      docker:
        image: debian
        timeout:
          minutes: 60
        steps:
          {%- set firmware_basename = basename(firmware_path) %}
          {%- set os_basename = basename(os_path) %}
          - 'apt-get update'
          - 'apt-get install -qy fdisk gdisk coreutils python3'
          - 'sgdisk -pO {{ firmware_basename }}'
          - 'sgdisk -pO {{ os_basename }}'
          - 'python3 merge-images.py --hybrid=1:EE --output=zcu102.img {{ firmware_basename }} {{ os_basename }}'
          - 'sgdisk -pO zcu102.img'
          - dd if=/dev/urandom of=random_data.capsule bs=1K count=1K

- deploy:
    to: flasher
    failure_retry: 3
    timeout:
      minutes: 60
    images:
      image:
        url: downloads://zcu102.img

- boot:
    method: minimal
    timeout:
      minutes: 10
    auto_login:
      login_prompt: 'login:'
      username: 'root'
      login_commands:
        - sudo su -
    prompts:
      - ewaol@(.*):[/~]\$
      - root@(.*):[/~]#
    transfer_overlay:
      download_command: wget -t 20 --waitretry 20 --retry-connrefused --retry-on-host-error --retry-on-http-error=401,403
      unpack_command: tar -C /var/lib/ -xzvf
{% endblock %}
